Subject: bug#8940: closed (Re: Evidence of bug in `random')

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 09 Jul 2011 08:16:02 +0000

Your bug report

#8940: Evidence of bug in `random'

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
8940: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=8940
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: Evidence of bug in `random'
From: Paul Eggert <[email-masked]>
To: Rafael D Sorkin <[email-masked]>
Cc: [email-masked]
Date: Sat, 09 Jul 2011 01:15:30 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

Thanks for that bug report.  Recently, I independently found
severe nonrandomness in 'random' and installed a patch
in the Emacs trunk as bzr 104596
<http://bzr.savannah.gnu.org/lh/emacs/trunk/revision/104956>.
This patch should appear in the next major release of Emacs.

Please give the patch a try.  It may not be as good as the Mersenne
twister etc., but it should be as good as Emacs 22 was.

I'll mark this bug report as 'done' for now, but we can
reopen it if the patch doesn't fix your problem.

Subject: Evidence of bug in `random'
From: Rafael D Sorkin <[email-masked]>
To: [email-masked]
Date: Sun, 26 Jun 2011 23:40:18 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

The following report refers to this version of emacs: 

  GNU Emacs 23.2.1 (x86_64-pc-linux-gnu, GTK+ Version 2.24.4) of
  2011-04-04 on crested, modified by Debian

Hello,

I'm sorry to submit a rather vague report, but I have found
strong evidence of some sort of problem with the random number
generator `random'.  I see the difficulty only indirectly in
some simulations I'm running.  Results obtained from elisp's
`random' disagree by over 6 sigma with results obtained from
`mt-random' (the "mersenne twister") or from the built-in
functions in both clisp and sbcl.  

Perhaps you could check for changes from earlier versions.
The problem seems absent from version 22.1.1.

Here's some info on the hardware from /proc/cpuinfo
  processor       : 0
  vendor_id       : GenuineIntel
  cpu family      : 6
  model           : 15
  model name      : Intel(R) Xeon(R) CPU           E5335  @
  2.00GHz
  stepping        : 11
  cpu MHz         : 1995.000
  cache size      : 4096 KB
  fpu             : yes
  fpu_exception   : yes
  cpuid level     : 10
  wp              : yes
  flags           : fpu vme de pse tsc msr pae mce cx8 apic sep
  mtrr pge mca cmov pat pse36 clflush dts acpi mmx fxsr sse sse2
  ss syscall lm constant_tsc arch\
  _perfmon pebs bts rep_good nopl tsc_reliable aperfmperf pni
  ssse3 cx16 hypervisor lahf_lm dts
  bogomips        : 3990.00
  clflush size    : 64
  cache_alignment : 64
  address sizes   : 40 bits physical, 48 bits virtual
  power management:

Thanks,

~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~
 Rafael Sorkin
 Perimeter Institute for Theoretical Physics
 31 Caroline Street North
 Waterloo, ON  N2L 2Y5
 Canada
~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~-~